########## R function: epGIGtwo ##########

# For computing the "G^IG2" function as appearing in
# Kim and Wand (2016).

# Last changed: 29 JAN 2016

epGIGtwo <- function(a,b,k)
{
   logbetaRecipObj <- eplogbeta(0,k-1,-b[2],1-k/2-b[1],a,c(0,b[2]),c(2,0,0))
   logbetaDenomObj <- eplogbeta(0,k-3,-b[2],1-k/2-b[1],a,c(0,b[2]),c(2,0,0))
   gFunObj <- epg(k-2,-b[2],1-k/2-b[1],a,c(0,b[2]),c(2,0,0))
     
   Erec <- exp(logbetaRecipObj$modulus - logbetaDenomObj$modulus)
 
   ans <- c(-1-gFunObj,-gFunObj/Erec) - a
   return(ans)
}

############ End of epGIGtwo ############
