########## R function: epGN function ##########

# For computing the "G^N" function as appearing
# in Kim and Wand (2016).

# Last changed: 29 JAN 2016

epGN <- function(a,b,aux)
{
   logalpha0Obj <- eplogalpha(0,a,b,aux)
   logalpha1Obj <- eplogalpha(1,a,b,aux)
   logalpha2Obj <- eplogalpha(2,a,b,aux)

   E1 <- (logalpha1Obj$sign)*exp(logalpha1Obj$modulus - logalpha0Obj$modulus)
   E2 <- exp(logalpha2Obj$modulus - logalpha0Obj$modulus)
   denom <- (E2 - E1^2)         
   ans <- c(E1,-0.5)/denom - a
   return(ans)
}

############ End of epGN ############
