########## R function: etaUpdate ##########

# For updating eta vectors for the normal random
# sample model, using either VMP or EP in the
# as appearing in Kim and Wand (2016).

# Last changed: 29 JAN 2016

etaUpdate <- function(a,b,messageName,aux=NULL,engineName="VMP")
{
   if (engineName=="VMP")
   {
      abRatio <- (a[1]+b[1]+1)/(a[2]+b[2])

      if (messageName=="p(x|mu,sigsq)->mu")
        ans <- abRatio*c(aux[2],(-0.5*aux[1]))

      if (messageName=="p(x|mu,sigsq)->sigsq")
      {
         entry2 <- (0.25*(aux[1] - 2*aux[2]*(a[1]+b[1]))/(a[2]+b[2])
                    - aux[1]*(a[1]+b[1])^2/(8*(a[2]+b[2])^2)
                    - 0.5*aux[3])
         ans <- c(-0.5*aux[1],entry2)            
      }    
      
      if (messageName=="p(sigsq|a)->sigsq")
        ans <- c(-1.5,-abRatio)
   
      if (messageName=="p(sigsq|a)->a")
        ans <- c(-0.5,-abRatio)
    }

   if (engineName=="EP")
   {
      if (messageName=="p(x|mu,sigsq)->mu")
      {
         ans <- epGN(a,b,aux)
      }

      if (messageName=="p(x|mu,sigsq)->sigsq")
      {
         ans <- epGIGone(a,b,aux)
      }    

      if (messageName=="p(sigsq|a)->sigsq")
      {
         ans <- epGIGtwo(a,b,3)
      }
        
      if (messageName=="p(sigsq|a)->a")
      {
         ans <- epGIGtwo(a,b,1)
      } 
   }
   return(ans)
}

############ End of etaUpdate ############
